#ifndef _USB8544_DEVICE_
#define _USB8544_DEVICE_

#include<windows.h>

//***********************************************************
// ADɼĲṹ
typedef struct _USB8544_PARA_AD
{
	LONG InputRange[2];		// ģѡ
	LONG CouplingType[2];	// (ֱ, )
	LONG Frequency;         // ɼƵ,λΪHz, [1, 1000000]
	LONG M_Length;          // Mγ(), ܵȡֵΧ1-8M, MNȲܴ8M
	LONG N_Length;          // Nγ(), ܵȡֵΧ1-8M, MNȲܴ8M,NΪ64
	LONG SummationMode;		// ۼģʽ(ֹ/ۼ//ݺ)
	LONG SummationTime;		// ۼӴ(1~10000)
	LONG AverageTime;		// ƽ
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
} USB8544_PARA_AD, *PUSB8544_PARA_AD;

// ADӲUSB8544_PARA_ADеCouplingTypeʹõѡ
const long USB8544_COUPLING_AC				= 0x00;	// 
const long USB8544_COUPLING_DC				= 0x01;	// ֱ

//***********************************************************
// ADӲUSB8544_PARA_ADеInputRangeʹõѡ
const long USB8544_INPUT_0_P2000mV		= 0x00; // 02000mV
const long USB8544_INPUT_0_P10000mV		= 0x01; // 010000mV

//***********************************************************
// ADӲUSB8544_PARA_ADеSummationModeԱʹôģʽѡ
const long USB8544_SUMMODE_NONE			= 0x00; // ֹۼ
const long USB8544_SUMMODE_ENDWISE		= 0x01; // ۼ
const long USB8544_SUMMODE_ABEAM		= 0x02; // ƽ
const long USB8544_SUMMODE_END_ABE		= 0x03; // ݺ

//***********************************************************
// ADӲUSB8544_PARA_ADеTriggerModeԱʹôģʽѡ
const long USB8544_TRIGMODE_POST		= 0x00; // 󴥷
const long USB8544_TRIGMODE_DELAY		= 0x01; // Ӳʱ


//***********************************************************
// ADӲUSB8544_PARA_ADеTriggerSourceԴźʹõѡ
const long USB8544_TRIGMODE_SOFT		= 0x00; // 
const long USB8544_TRIGSRC_DTR			= 0x01; // ѡDTRΪԴ

//***********************************************************
// ADӲUSB8544_PARA_ADеTriggerDirʹõѡ
const long USB8544_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(͵ƽ)
const long USB8544_TRIGDIR_POSITIVE		= 0x01; // 򴥷(ߵƽ)
const long USB8544_TRIGDIR_POSIT_NEGAT	= 0x02; // 򴥷(/͵ƽ)

//***********************************************************
// ADӲUSB8544_PARA_ADеClockSourceʱԴʹõѡ
const long USB8544_CLOCKSRC_IN			= 0x00; // ڲʱӶʱ
const long USB8544_CLOCKSRC_OUT			= 0x01; // ⲿʱӶʱ(ʹCN1ϵCLKINź)


//*************************************************************************************
// ADʵӲ
typedef struct _USB8544_STATUS_AD     
{
	LONG bADEanble;	// ADǷѾʹܣ=TRUE:ʾʹܣ=FALSE:ʾδʹ
	LONG bTrigger;  // ADǷ񱻴=TRUE:ʾѱ=FALSE:ʾδ
	LONG bComplete; // ADǷתǷ=TRUE:ʾѽ=FALSE:ʾδ
	LONG bAheadTrig;// ADǷǰ=TRUE:ʾǰ=FALSE:ʾδǰ
} USB8544_STATUS_AD, *PUSB8544_STATUS_AD;

//***********************************************************
// ӿ
#ifndef _USB8544_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	HANDLE DEVAPI FAR PASCAL USB8544_CreateDevice(int DeviceLgcID = 0); // 豸(úʹϵͳ߼豸ID
	BOOL DEVAPI FAR PASCAL USB8544_GetDeviceCurrentID(HANDLE hDevice, PLONG DeviceLgcID); // ȡõǰ豸߼IDźID
	BOOL DEVAPI FAR PASCAL USB8544_ResetDevice(HANDLE hDevice);		 // λUSB豸
    BOOL DEVAPI FAR PASCAL USB8544_ReleaseDevice(HANDLE hDevice);    // 豸

	//####################### ADݶȡ #################################
	BOOL DEVAPI FAR PASCAL USB8544_ADCalibration(				// ADԶУ׼
									HANDLE hDevice);			// 豸,CreateDevice
	
    BOOL DEVAPI FAR PASCAL USB8544_InitDeviceAD(				// ʼ豸,TRUE,豸̿ʼ.
									HANDLE hDevice,				// 豸,ӦCreateDevice
									PUSB8544_PARA_AD pADPara);  // Ӳ, ڴ˺оӲ״̬	

	BOOL DEVAPI FAR PASCAL USB8544_StartDeviceAD(				// ڳʼ֮豸
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB8544_SetDeviceTrigAD(				// 豸ʹ󣬲¼ֻдԴΪʱЧ
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB8544_GetDevStatusAD(				// ȡADɼ״̬
									HANDLE hDevice,				// 豸
									PUSB8544_STATUS_AD pADStatus);// AD״̬

	ULONG DEVAPI FAR PASCAL USB8544_GetSDRAMSize(				// ذDDR2СλΪMb
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB8544_StopDeviceAD(				// 豸֮ͣ豸
									HANDLE hDevice);			// 豸

    BOOL DEVAPI FAR PASCAL USB8544_ReadDeviceAD(				// ʼ豸󣬼ô˺ȡ豸ϵAD
									HANDLE hDevice,				// 豸,ӦCreateDevice
									ULONG ADBuffer[],			// ڽݵû
									LONG nReadSizeWords,		// ȡADݵĳ()  
									ULONG ulStartAddr,			// RAMеʼַ
									PLONG nRetSizeWords = NULL);// ʵʷݵĳ()

    BOOL DEVAPI FAR PASCAL USB8544_ReleaseDeviceAD( HANDLE hDevice); // ֹͣADɼͷADռԴ

   	//################# ADӲ ########################	
	BOOL DEVAPI FAR PASCAL USB8544_SaveParaAD(HANDLE hDevice, PUSB8544_PARA_AD pADPara);  
    BOOL DEVAPI FAR PASCAL USB8544_LoadParaAD(HANDLE hDevice, PUSB8544_PARA_AD pADPara);
    BOOL DEVAPI FAR PASCAL USB8544_ResetParaAD(HANDLE hDevice, PUSB8544_PARA_AD pADPara); // ADָĬֵ

	//############################################################################
	BOOL DEVAPI FAR PASCAL USB8544_GetDevVersion(				// ȡ豸̼汾
									HANDLE hDevice,				// 豸,CreateDevice
									PULONG pulFmwVersion,		// ̼汾
									PULONG pulDriverVersion);	// 汾


	//############################ ̲߳ ################################
	HANDLE DEVAPI FAR PASCAL USB8544_CreateSystemEvent(void); 	// ںϵͳ¼
	BOOL DEVAPI FAR PASCAL USB8544_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

// Զ
#ifndef _USB8544_DRIVER_
#ifndef _WIN64
#pragma comment(lib, "USB8544_32.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB8544_32.dll...")
#pragma message("======== Successfully linked with USB8544_32.dll")
#else
#pragma comment(lib, "USB8544_64.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB8544_64.dll...")
#pragma message("======== Successfully linked with USB8544_64.dll")
#endif

#endif

#endif; // _USB8544_DEVICE_